﻿Public Class frm_Main

    Private Sub btn_openDB_Click(sender As System.Object, e As System.EventArgs) Handles btn_openDB.Click
        Dim dbProvider As String = Nothing ' Содержит строку инициализации Database Provider (обработчик базы данных)
        Dim dbSource As String = Nothing ' Местоположение базы данных
        Dim str_queryString As String = Nothing ' переменная, содержащая SQL-запрос к БД

        dgv_Main.DataSource = Nothing
        dgv_Main.DataMember = Nothing

        ' Объявляем провайдера для работы с MS Access БД:
        dbProvider = "PROVIDER=Microsoft.Jet.OLEDB.4.0;"

        ' Указываем путь до файла БД: 
        dbSource = "Data Source = " & Application.StartupPath & "\db\Songs.mdb"

        ' Открываем базу данных:
        openDatabase(dbProvider, dbSource)

        ' подключаемся к БД и выбираем данные по SQL-запросу из БД:
        str_queryString = "SELECT * FROM Songs ORDER BY SingerName" ' выбираем все записи из БД, сортируем по имени исполнителя
        connectToDB(str_queryString)

        ' Заполняем выбранными из БД данными DataSet:
        tblName = "BazaPesen"
        fillDataSet(tblName)

        ' Закрываем соединение с базой данных:
        closeDatabase()

        ' Заполняем данными таблицу DataGridView данными из DataSet:
        With dgv_Main
            .Enabled = False
            .DataSource = WorkWithBase.ds
            .DataMember = tblName
            .Enabled = True
            ' включаем автоподбор ширины столбцов DataGridView
            .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DisplayedCells ' = True
        End With

    End Sub

    Private Sub frm_Main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Text = "Пример работы с БД"

    End Sub

    Private Sub btn_saveToDB_Click(sender As System.Object, e As System.EventArgs) Handles btn_saveToDB.Click
        '' выясняем, какое действие следует произвести: если DataSet пуст - добавляем новую запись в БД:
        'If ds.Tables(tblName).Rows.Count = 0 Then
        '    ' формируем новую строку в БД:
        '    Dim dsNewRow As DataRow
        '    dsNewRow = ds.Tables(tblName).NewRow()
        '    dsNewRow.Item("SingerName") = removeBadCharsFromString(UCase(txtboxSinger.Text.Trim))
        '    dsNewRow.Item("SongName") = removeBadCharsFromString(UCase(txtboxSong.Text.Trim))
        '    dsNewRow.Item("Poet") = removeBadCharsFromString(UCase(txtboxPoet.Text.Trim))
        '    dsNewRow.Item("Kompozitor") = removeBadCharsFromString(UCase(txtboxCompositor.Text.Trim))
        '    dsNewRow.Item("FileName") = removeBadCharsFromString(UCase(txtboxFileName.Text.Trim))
        '    dsNewRow.Item("IstochnikFonogramm") = removeBadCharsFromString(UCase(txtboxIstochnikFonogrammy.Text.Trim))
        '    dsNewRow.Item("Genre") = removeBadCharsFromString(UCase(txtboxGenre.Text.Trim))

        '    ' Вызываем процедуру сохранения изменений в БД:
        '    saveToDatabase(tblName, dsNewRow)
        '    ' Переходим на новую запись:
        '    dgvAdd.CurrentCell = dgvAdd.Item(1, dgvAdd.Rows.Count - 1)
        'Else
        '    ' если DataSet не пуст, значит обновляем запись в БД:
        '    ' так как выборка идёт по жёсткому критерию, ROW всегда будет равен 0, хардкодим 0 в код
        '    Dim int_RowNumber As Integer = 0
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("SingerName") = removeBadCharsFromString(UCase(txtboxSinger.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("SongName") = removeBadCharsFromString(UCase(txtboxSong.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("Poet") = removeBadCharsFromString(UCase(txtboxPoet.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("Kompozitor") = removeBadCharsFromString(UCase(txtboxCompositor.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("FileName") = removeBadCharsFromString(UCase(txtboxFileName.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("IstochnikFonogramm") = removeBadCharsFromString(UCase(txtboxIstochnikFonogrammy.Text.Trim))
        '    ds.Tables(tblName).Rows(int_RowNumber).Item("Genre") = removeBadCharsFromString(UCase(txtboxGenre.Text.Trim))
        '    updateDataBase(tblName)
        'End If
    End Sub

    Private Sub dgv_Main_CellClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Main.CellClick

        ' обрабатываем клик по DataGridView
        Dim int_SelectedRowNumber As Integer ' номер выделенной строки в DataGridView
        ' получаем номер выделенной строки в DataGridView
        int_SelectedRowNumber = dgv_Main.CurrentCell.RowIndex

        ' выбираем информацию из DataSet, заполняем ею контролы на форме
        ' данные также можно выбирать из DataGridView
        txtbox_Compositor.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("Kompozitor").ToString
        txtbox_FileName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("FileName").ToString
        txtbox_Poet.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("Poet").ToString
        txtbox_SingerName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("SingerName").ToString
        txtbox_SongName.Text = ds.Tables(tblName).Rows(int_SelectedRowNumber).Item("SongName").ToString

    End Sub
End Class
